
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Declaration File Contents
!!!!! File Name: CFCHotKey.inc
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

OMIT('_EndOfInclude_',_CFCHKBClassPresent_)
_CFCHKBClassPresent_               EQUATE(1)

 INCLUDE('CFCAPI.inc'),ONCE
 INCLUDE('CFCWndProc.inc'),ONCE

! Hot Key base class
CFCHotKeyBase     CLASS(CFCWndProc),TYPE,MODULE('CFCHotKey.clw'),LINK('CFCHotKey.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
FlagCtrl              BYTE                                     ! flags
FlagAlt               BYTE
FlagShift             BYTE
FlagWin               BYTE
VK_Code               LONG                                     ! key code
SaveToIni             PROCEDURE(STRING inSection,STRING inCtrlName,STRING inFileName)
RestoreFromIni        PROCEDURE(STRING inSection,STRING inCtrlName,STRING inFileName)
                  END

! showing the hotkey
CFCHotKeyEntry    CLASS(CFCHotKeyBase),TYPE,MODULE('CFCHotKey.clw'),LINK('CFCHotKey.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
EntryFEQ              LONG                                     ! entry control
EntryVar              ANY                                      ! entry variable
HotKeyString          STRING(256)                              ! hotkey string

Init                  PROCEDURE(LONG inEntryFEQ,*ANY inEntryVar)
Kill                  PROCEDURE
GetState              PROCEDURE(LONG inVK),BYTE
CallBackProc          PROCEDURE(ULONG hWnd,ULONG Msg,ULONG wParam,LONG lParam),LONG,VIRTUAL
SaveToIni             PROCEDURE(STRING inSection,STRING inCtrlName,STRING inFileName)
RestoreFromIni        PROCEDURE(STRING inSection,STRING inCtrlName,STRING inFileName)
                  END

! using and process the hotkeys
CFCHotKey         CLASS(CFCHotKeyBase),TYPE,MODULE('CFCHotKey.clw'),LINK('CFCHotKey.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
Wnd                   &WINDOW                                  ! window which process the keys
HotKeyID              LONG(101)                                ! key ID

Init                  PROCEDURE(WINDOW inWindowLabel)
Kill                  PROCEDURE
RegisterHotKey        PROCEDURE(),LONG
UnregHotKey           PROCEDURE()
CallBackProc          PROCEDURE(ULONG hWnd,ULONG Msg,ULONG wParam,LONG lParam),LONG,VIRTUAL
TakeAccepted          PROCEDURE(),VIRTUAL
                  END


_EndOfInclude_


