!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: CFCRebar.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER

 INCLUDE('CFCRebar.inc'),ONCE
!**************************************************************************************************************
CFCRebar.CreateRebar          PROCEDURE(ULONG inParentHWND)
rbi                LIKE(CFC_REBARINFO)
cstrRebarClassName CSTRING('ReBarWindow32')
 CODE
 SELF.ParentHWND = inParentHWND
 SELF.hWndRB = CFC_CreateWindowEx(CFC_WS_EX_TOOLWINDOW, |
                                  ADDRESS(cstrRebarClassName), |
                                  0, |
                                  CFC_WS_CHILD + CFC_WS_VISIBLE + CFC_WS_CLIPSIBLINGS + |
                                  CFC_WS_CLIPCHILDREN + CFC_WS_BORDER + |
                                  CFC_RBS_VARHEIGHT + CFC_RBS_DBLCLKTOGGLE + CFC_RBS_BANDBORDERS + |
                                  CFC_CCS_NODIVIDER + CFC_CCS_TOP, |
                                  0,0,0,0, |
                                  SELF.ParentHWND, |
                                  0, |
                                  SYSTEM{Prop:AppInstance}, |
                                  0)

 ! Initialize and send the REBARINFO structure.
 IF SELF.hWndRB
    rbi.cbSize = SIZE(CFC_REBARINFO)
    rbi.fMask  = 0
    rbi.himl   = 0
    Err# = CFC_SendMessage(SELF.hWndRB, CFC_RB_SETBARINFO, 0, ADDRESS(rbi))
 END
 RETURN SELF.hWndRB
CFCRebar.AddToolbar PROCEDURE(*CFCToolbar inT)
rbBand             LIKE(CFC_REBARBANDINFO)
 CODE
 rbBand.cbSize = SIZE(CFC_REBARBANDINFO)
 rbBand.fMask = CFC_RBBIM_TEXT + |
                   CFC_RBBIM_STYLE + CFC_RBBIM_CHILD  +  CFC_RBBIM_CHILDSIZE + |
                   CFC_RBBIM_SIZE + CFC_RBBIM_IDEALSIZE + CFC_RBBIM_ID

 Err# = inT.GetMaxSizeItem(outCx#,outCy#)

 rbBand.lpText     = 0
 rbBand.hwndChild  = inT.hwndTB
 rbBand.cxMinChild = outCx#
 rbBand.cyMinChild = outCy# + 2
 rbBand.cx         = outCx# + 2
 rbBand.cxIdeal    = outCx# + 2
 rbBand.wID        = 0
 rbBand.fStyle = CFC_RBBS_CHILDEDGE + CFC_RBBS_GRIPPERALWAYS! + CFC_RBBS_BREAK
 Err# = CFC_SendMessage(SELF.hWndRB, CFC_RB_INSERTBANDA,4294967295,ADDRESS(rbBand))
 
CFCRebar.CallBackProc         PROCEDURE(ULONG hWnd,ULONG inMsg,ULONG wParam,LONG lParam)
loc:WM_NOTIFY        EQUATE(004Eh)
loc:WM_SIZE          EQUATE(0005h)

loc:NMHDR            LIKE(CFC_NMHDR)

loc:wParamG          GROUP,OVER(wParam)
low                     USHORT
high                    USHORT
                     END
loc:lParamG          GROUP,OVER(lParam)
low                     SHORT
high                    SHORT
                     END

 CODE
 IF inMsg = loc:WM_NOTIFY
    CFC_MEMCPY(ADDRESS(loc:NMHDR),lParam,SIZE(CFC_NMHDR))
    IF loc:NMHDR.hwndFrom = SELF.hWndRB
       ! supress the band dragging
       IF loc:NMHDR._code = CFC_RBN_BEGINDRAG
          RETURN 1
       END
    END
 END

 ! the parent control has changed its size
 ! we must change the rebar size
 IF inMsg = loc:WM_SIZE
    Err# = CFC_MoveWindow(SELF.hWndRB,0,0,loc:lParamG.low,loc:LParamG.high,1)
 END

 RETURN PARENT.CallBackProc(hWnd,inMsg,wParam,lParam)


