
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Declaration File Contents
!!!!! File Name: CFCToolbar.inc
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

OMIT('_EndOfInclude_',_CFCToolbarClassPresent_)
_CFCToolbarClassPresent_               EQUATE(1)

 INCLUDE('CFCAPI.inc'),ONCE
 INCLUDE('CFCWndProc.inc'),ONCE
 INCLUDE('CFCComctrl.inc'),ONCE
 INCLUDE('CFCGDI.inc'),ONCE
 INCLUDE('CFCTooltips.inc'),ONCE

! access levels
CFC_TBA_GRANTED            EQUATE(0)
CFC_TBA_DENIED             EQUATE(1)

CFC_TBS_TEXTWITHICON       EQUATE(0)
CFC_TBS_TEXTONLY           EQUATE(1)
CFC_TBS_ICONONLY           EQUATE(2)

CFC_ToolbarImagePoolQ QUEUE,TYPE
IconName                 STRING(260)
hBitmap                  ULONG
ImageIdx                 LONG
Width                    LONG
Height                   LONG
                      END

CFC_ToolbarButtonsQ   QUEUE,TYPE
ButtonID                 LONG
B                        &CFCTbrButton
                      END

CFCToolbar          CLASS,TYPE,MODULE('CFCToolbar.clw'),LINK('CFCToolbar.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
hWndTB                 ULONG
ParentHWND             ULONG
tbrIpool               &CFC_ToolbarImagePoolQ
tbrB                   &CFC_ToolbarButtonsQ
Cnt                    &CFCCommandCnt
TT                     &CFCTooltipsClass
tbrImageHeight         LONG
tbrImageWidth          LONG
InitStateBuffer        &STRING
RestoredStateBuffer    &STRING
NMTBCUSTOMDRAW         LIKE(CFC_NMTBCUSTOMDRAW)

Construct              PROCEDURE
Destruct               PROCEDURE
CreateToolbar          PROCEDURE(ULONG inParentHWND,<LONG inStyle>,<LONG inTooltipStyle>),ULONG,PROC
AddIconToImagePool     PROCEDURE(STRING inIconName,<STRING inDllName>,<LONG inWidth>,<LONG inHeight>),ULONG,PROC
GetIconFromImagePool   PROCEDURE(STRING inIconName,<LONG inWidth>,<LONG inHeight>),LONG
AddButton              PROCEDURE(*CFCTbrButton inB, <STRING inText>, LONG inStyle,LONG inPos,BYTE inFlagIcon),LONG,PROC
AddButton              PROCEDURE(*CFCTbrButton inB,<STRING inText>,<LONG inPos>,<BYTE inFlagIcon>),LONG,PROC
AddCheckButton         PROCEDURE(*CFCTbrButton inB, <STRING inText>,<LONG inPos>,<BYTE inFlagIcon>),LONG,PROC
AddRadioButton         PROCEDURE(*CFCTbrButton inB, <STRING inText>,<LONG inPos>,<BYTE inFlagIcon>),LONG,PROC
AddDropDownButton      PROCEDURE(*CFCTbrButton inB, <STRING inText>,<LONG inPos>,<BYTE inFlagIcon>),LONG,PROC
AddWholeDropDownButton PROCEDURE(*CFCTbrButton inB, <STRING inText>,<LONG inPos>,<BYTE inFlagIcon>),LONG,PROC
AddSeparator           PROCEDURE(<LONG inPos>),LONG,PROC
DeleteSeparatorByPos   PROCEDURE(LONG inPos)
GetButtonByID          PROCEDURE(LONG inButtonID),*CFCTbrButton
GetButtonIDByPos       PROCEDURE(LONG inPosIndex),LONG
SetCommandCnt          PROCEDURE(*CFCCommandCnt inCnt)
SetTbrImageSize        PROCEDURE(SHORT inWidth,SHORT inHeight)
ButtonCount            PROCEDURE,LONG
GetAnchorHighlight     PROCEDURE,LONG
SetAnchorHighlight     PROCEDURE(LONG inFlagAnchor),LONG
GetButtonSize          PROCEDURE(*LONG outWidth,*LONG outHeight)
GetColorScheme         PROCEDURE(*ULONG out_clrBtnHighlight,*ULONG out_clrBtnShadow)
SetColorScheme         PROCEDURE(ULONG in_clrBtnHighlight,ULONG in_clrBtnShadow)
GetHotItem             PROCEDURE,LONG
GetMaxSizeItem         PROCEDURE(*LONG outCx,*LONG outCy),LONG
GetPadding             PROCEDURE(*SHORT outHoriz,*SHORT outVert)
SetPadding             PROCEDURE(SHORT inHoriz,SHORT inVert)
GetRows                PROCEDURE,LONG
SetMaxTextRows         PROCEDURE(LONG inRows),LONG,PROC
GetTextRows            PROCEDURE,LONG
AutoSize               PROCEDURE
RefreshTooltips        PROCEDURE
SetButtonSize          PROCEDURE(SHORT dx,SHORT dy),LONG,PROC
SetButtonWidth         PROCEDURE(SHORT minWidth,SHORT maxWidth),LONG,PROC
SetDrawTextFlags       PROCEDURE(LONG inMask,LONG inFlags),LONG,PROC
Refresh                PROCEDURE
SaveState              PROCEDURE
SaveStateToFile        PROCEDURE(STRING inFileName),LONG,PROC
RestoreStateFromFile   PROCEDURE(STRING inFileName),LONG,PROC
CustomizeDialog        PROCEDURE
MoveButton             PROCEDURE(LONG inOldPos, LONG inNewPos),LONG,PROC
PressButton            PROCEDURE(*CFCTbrButton inB, BYTE inFlagPress),LONG,PROC
SetIndent              PROCEDURE(LONG inIndent),LONG,PROC
SetRows                PROCEDURE(LONG inRows,BYTE inFlagLarge,*CFC_RECT outRC)
OnReset                PROCEDURE,VIRTUAL
OnToolbarChange        PROCEDURE,VIRTUAL
                    END

CFCTbrButton        CLASS,TYPE,MODULE('CFCToolbar.clw'),LINK('CFCToolbar.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
Toolbar                &CFCToolbar ! parent toolbar object
ButtonID               LONG        ! button id
Text                   STRING(256) ! button text
cstrText               &CSTRING    ! button cstr buffer
ToolID                 LONG        ! tooltip ID
TBBUTTON               LIKE(CFC_TBBUTTON) ! button props buffer
NMTBCUSTOMDRAW         LIKE(CFC_NMTBCUSTOMDRAW) ! customdraw info

Construct              PROCEDURE
Destruct               PROCEDURE
SetIcon                PROCEDURE(STRING inIconName,<STRING inDllName>,<LONG inWidth>,<LONG inHeight>),LONG,PROC
SetText                PROCEDURE(STRING inText),LONG,PROC
SetTooltip             PROCEDURE(STRING inText)
SetCx                  PROCEDURE(LONG cx),LONG,PROC
GetTBBUTTON            PROCEDURE,STRING
UpdateTBBUTTON         PROCEDURE
CheckButton            PROCEDURE(BYTE inFlagCheck),LONG,PROC
GetButtonIndex         PROCEDURE,LONG
Delete                 PROCEDURE,LONG,PROC
Enable                 PROCEDURE(BYTE inFlagEnable),LONG,PROC
HideButton             PROCEDURE(BYTE inFlagHide),LONG,PROC
GetState               PROCEDURE,LONG
GetStyle               PROCEDURE,LONG
GetCx                  PROCEDURE,LONG
GetRect                PROCEDURE(*CFC_RECT outRect),LONG,PROC
IsChecked              PROCEDURE,BYTE
IsEnabled              PROCEDURE,BYTE
IsHidden               PROCEDURE,BYTE
IsPressed              PROCEDURE,BYTE
IsIndeterminate        PROCEDURE,BYTE
IsHighlighted          PROCEDURE,LONG
MarkButton             PROCEDURE(BYTE inFlagMark),LONG,PROC
OnCommand              PROCEDURE,VIRTUAL
OnDropDown             PROCEDURE,VIRTUAL
CheckButtonAccess      PROCEDURE,LONG,VIRTUAL
                    END

CFC_ToolbarQ        QUEUE,TYPE
T                      &CFCToolbar
                    END

CFCToolbarManager   CLASS(CFCWndProc),TYPE,MODULE('CFCToolbar.clw'),LINK('CFCToolbar.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
tbrQ                   &CFC_ToolbarQ
Construct              PROCEDURE
Destruct               PROCEDURE
AddToolbar             PROCEDURE(*CFCToolbar inTbr)
CallBackProc           PROCEDURE(ULONG hWnd,ULONG inMsg,ULONG wParam,LONG lParam),LONG,VIRTUAL
                    END


_EndOfInclude_


