
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Declaration File Contents
!!!!! File Name: CFCTooltips.inc
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

OMIT('_EndOfInclude_',_CFCTooltipsClassPresent_)
_CFCTooltipsClassPresent_               EQUATE(1)

 INCLUDE('CFCAPI.inc'),ONCE
 INCLUDE('CFCWndProc.inc'),ONCE
 INCLUDE('CFCComctrl.inc'),ONCE

 MAP
 END

CFCTooltipsQ      QUEUE,TYPE
ID                   ULONG     ! hwnd or tool ID
FlagHwnd             BYTE      ! true, if ID is a hwnd
cstrText             &CSTRING  ! tooltip text
                  END


CFCTooltipsClass  CLASS(CFCWndProc),TYPE,MODULE('CFCTooltips.clw'),LINK('CFCTooltips.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
hWndTt               ULONG
ParentHWND           ULONG
ttQ                  &CFCTooltipsQ
Cnt                  &CFCCommandCnt

TitleIconID          ULONG
ToolTitle            CSTRING(101)

Construct            PROCEDURE
Destruct             PROCEDURE
Init                 PROCEDURE(ULONG inParentHWND)
Kill                 PROCEDURE
SetCommandCnt        PROCEDURE(*CFCCommandCnt inCnt)
CreateTooltip        PROCEDURE(<LONG inStyle>),ULONG,PROC
AddTool              PROCEDURE(STRING inToolText,<*CFC_Rect in_rc>,<LONG inFlags>),LONG,PROC
AddTool              PROCEDURE(<*CFC_Rect in_rc>,<LONG inFlags>),LONG,PROC
SetMaxTipWidth       PROCEDURE(LONG inWidth),LONG,PROC
Activate             PROCEDURE(BYTE inFlagActivate)
SetTitle             PROCEDURE(STRING inTitle,ULONG inIconID),LONG,PROC
RemoveTitle          PROCEDURE
SetToolText          PROCEDURE(ULONG inID,STRING inText),LONG,PROC
GetToolCount         PROCEDURE,LONG
GetDelayTime         PROCEDURE(LONG inDuration),LONG
GetAutoPopTime       PROCEDURE,LONG
GetReshowTime        PROCEDURE,LONG
GetInitialTime       PROCEDURE,LONG
Update               PROCEDURE
DelTool              PROCEDURE(LONG inID),LONG,PROC
ActivateTrack        PROCEDURE(ULONG inID,BYTE inAction),LONG,PROC
CallBackProc         PROCEDURE(ULONG hWnd,ULONG inMsg,ULONG wParam,LONG lParam),LONG,VIRTUAL
OnPop                PROCEDURE,VIRTUAL
OnShow               PROCEDURE,VIRTUAL
OnLinkClick          PROCEDURE,VIRTUAL
OnUpdate             PROCEDURE,VIRTUAL
GetToolInfoByIdx     PROCEDURE(LONG inIdx,*CFC_TOOLINFO outTI),LONG
GetToolInfoByID      PROCEDURE(ULONG inID,*CFC_TOOLINFO outTI),LONG
GetBubblesize        PROCEDURE(ULONG inID,*LONG outWidth,*LONG outHeight),LONG
GetCurrentToolInfo   PROCEDURE(*CFC_TOOLINFO outTI),LONG
IsToolVisible        PROCEDURE,ULONG
GetMargin            PROCEDURE(*CFC_RECT outRect)
SetMargin            PROCEDURE(*CFC_RECT inRect)
GetMaxTipWidth       PROCEDURE,LONG
GetToolText          PROCEDURE(ULONG inID),STRING
GetToolTextLen       PROCEDURE(ULONG inID),LONG
GetTipBKColor        PROCEDURE,ULONG
SetTipBKColor        PROCEDURE(ULONG inColor)
GetTipTextColor      PROCEDURE,ULONG
SetTipTextColor      PROCEDURE(ULONG inColor)
GetTitleIconID       PROCEDURE,ULONG
GetTitleCopiedHIcon  PROCEDURE,ULONG
GetTitleText         PROCEDURE,STRING
GetTitleTextLen      PROCEDURE,LONG
SetNewToolRect       PROCEDURE(ULONG inID,*CFC_RECT in_rc)
PopTooltip           PROCEDURE
PopupTooltip         PROCEDURE
SetTrackPos          PROCEDURE(SHORT xPos,SHORT yPos)
SetDelayTime         PROCEDURE(LONG inDuration,LONG inTime)
SetAutoPopTime       PROCEDURE(LONG inTime)
SetReshowTime        PROCEDURE(LONG inTime)
SetInitialTime       PROCEDURE(LONG inTime)
                  END


CFC_tt_queue           QUEUE,TYPE
TT                        &CFCTooltipsClass
                       END

CFCTooltipManagerClass CLASS,TYPE,MODULE('CFCTooltips.clw'),LINK('CFCTooltips.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
hHook                     ULONG
MenuAnimation             LONG
MenuFade                  LONG
ttq                       &CFC_tt_queue
Construct                 PROCEDURE
Destruct                  PROCEDURE
AddTooltip                PROCEDURE(*CFCTooltipsClass inTT)
OnPop                     PROCEDURE(ULONG in_hwnd,ULONG wParam, LONG lParam)
OnShow                    PROCEDURE(ULONG in_hwnd,ULONG wParam, LONG lParam)
OnLinkClick               PROCEDURE(ULONG in_hwnd,ULONG wParam, LONG lParam)
                       END

_EndOfInclude_


