
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Declaration File Contents
!!!!! File Name: cfcpanel.inc
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

OMIT('_EndOfInclude_',_CFCHTMLPanelPresent_)
_CFCHTMLPanelPresent_               EQUATE(1)

 INCLUDE('dynstr.inc'),ONCE
 INCLUDE('cfchtml.inc'),ONCE

CFC_HTMLTxtFile       FILE,DRIVER('ASCII'),CREATE,BINDABLE
Record                   RECORD,PRE()
DataStr                     STRING(1024)
                         END
                     END                       

CFC_PanelGroupsType           QUEUE,TYPE
GroupID                          STRING(255)
GroupName                        STRING(255)
ImageName                        STRING(260)
                              END

CFC_PanelItemsType            QUEUE,TYPE
GroupID                          STRING(255)
ItemID                           STRING(255)
ItemText                         STRING(255)
ImageName                        STRING(260)
FlagSepBefore                    BYTE
TooltipText                      STRING(1024)
CheckGroup                       STRING(255)
FlagChecked                      BYTE
                              END


CFC_PanelTextBlocksType       QUEUE,TYPE
GroupID                          STRING(255)
BlockID                          STRING(255)
Text                             STRING(1024)
                              END

CFC_PanelStateType            QUEUE,TYPE
ID                               STRING(255)
state                            STRING(20)
                              END

CFCHTMLPanelClass             CLASS,TYPE,MODULE('cfcpanel.clw'),LINK('cfcpanel.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
pg                               &CFC_PanelGroupsType
pi                               &CFC_PanelItemsType
ptb                              &CFC_PanelTextBlocksType
state_q                          &CFC_PanelStateType
html                             &CFCHTMLClass

FileName                         STRING(260)
IniFileName                      STRING(260)
PanelDesc                        STRING(260)

img_expand                       STRING(260)
img_contract                     STRING(260)
img_check                        STRING(260)
padding_px                       LONG ! 
FlagNoImages                     BYTE !   
FontName                         STRING(255)
FontSize                         STRING(255)

Construct                        PROCEDURE
Destruct                         PROCEDURE
Init                             PROCEDURE(STRING inFileName,*CFCHTMLClass in_html)
Kill                             PROCEDURE
SetIniFileName                   PROCEDURE(STRING inFileName,STRING inPanelDesc)
OpenHeadTag                      PROCEDURE
WriteStyle                       PROCEDURE
WriteContent                     PROCEDURE
CloseHeadTag                     PROCEDURE
SaveToFile                       PROCEDURE(*IDynStr inDS)
AddGroup                         PROCEDURE(STRING inGroupID,STRING inGroupName,STRING inImage)
AddItem                          PROCEDURE(STRING inGroupID,STRING inItemID,STRING inItemText,STRING inImage,<BYTE inFlagSepBefore>,<STRING inCheckGroup>)
AddTextBlock                     PROCEDURE(STRING inGroupID,STRING inBlockID,STRING inText)
SetItemTooltip                   PROCEDURE(STRING inItemID,STRING inTooltipText)
SetItemIcon                      PROCEDURE(STRING inItemID,STRING inImage)
SetItemText                      PROCEDURE(STRING inItemID,STRING inText)
SetItemChecked                   PROCEDURE(STRING inItemID)
SetItemEnabled                   PROCEDURE(STRING inItemID)
SetItemDisabled                  PROCEDURE(STRING inItemID)
DoubleSlash                      PROCEDURE(STRING inStr),STRING
Refresh                          PROCEDURE
Run                              PROCEDURE
SaveState                        PROCEDURE
RestoreState                     PROCEDURE
SaveToIni                        PROCEDURE
RestoreFromIni                   PROCEDURE
                              END

_EndOfInclude_



