!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: CFCAlertKeys.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER

 MAP
 END

 INCLUDE('CFCAlertKeys.inc'),ONCE

CFCAlertKeysClass.Construct                      PROCEDURE
 CODE
 SELF.AKQ &= NEW CFCAlertKeysQueue

CFCAlertKeysClass.Destruct                       PROCEDURE
 CODE
 IF NOT SELF.AKQ &= NULL THEN DISPOSE(SELF.AKQ).
CFCAlertKeysClass.AddKey                         PROCEDURE(LONG inKeyCode)
 CODE
 SELF.AKQ.AlertKeycode = inKeyCode
 GET(SELF.AKQ,SELF.AKQ.AlertKeycode)
 IF ERRORCODE()
    CLEAR(SELF.AKQ)
    SELF.AKQ.AlertKeycode = inKeyCode
    ADD(SELF.AKQ)
 END



CFCAlertKeysClass.DeleteKey                         PROCEDURE(LONG inKeyCode)
 CODE
 SELF.AKQ.AlertKeycode = inKeyCode
 GET(SELF.AKQ,SELF.AKQ.AlertKeycode)
 IF NOT ERRORCODE()
    DELETE(SELF.AKQ)
 END



CFCAlertKeysClass.IsKeyExists                         PROCEDURE(LONG inKeyCode)
loc:RetValue BYTE
 CODE
 SELF.AKQ.AlertKeycode = inKeyCode
 GET(SELF.AKQ,SELF.AKQ.AlertKeycode)
 IF NOT ERRORCODE()
    loc:RetValue = 1
 END
 RETURN loc:RetValue



CFCAlertKeysClass.ProcessAlertKeys               PROCEDURE(LONG inKeyCode)
 CODE
CFCAlertKeysClass.SetKeys                           PROCEDURE
 CODE
 IF NOT SELF.AKQ &= NULL
    LOOP j# = 1 TO RECORDS(SELF.AKQ)
       GET(SELF.AKQ,j#)
       ALERT(SELF.AKQ.AlertKeycode)
    END
 END
CFCAlertKeysClass.TranslateAlert                 PROCEDURE
loc:keycode LONG
 CODE
 IF EVENT() = EVENT:AlertKey
    IF NOT SELF.AKQ &= NULL
       loc:keycode = KEYCODE()
       SELF.AKQ.AlertKeycode = loc:keycode
       GET(SELF.AKQ,SELF.AKQ.AlertKeycode)
       IF NOT ERRORCODE()
          SELF.ProcessAlertKeys(loc:keycode)
       END
    END
 END
! *********************************************************************************************
CFCAlertKeysWindowClass.Init                           PROCEDURE(*CFCAlertKeysClass inAK)
 CODE
 SELF.AK &= inAK
 IF NOT SELF.AK &= NULL
    LOOP j# = 1 TO RECORDS(SELF.AK.AKQ)
       GET(SELF.AK.AKQ,j#)
       ALERT(SELF.AK.AKQ.AlertKeycode)
    END
 END
CFCAlertKeysWindowClass.TranslateAlert                 PROCEDURE
loc:keycode LONG
 CODE
 IF EVENT() = EVENT:AlertKey
    IF NOT SELF.AK &= NULL
       loc:keycode = KEYCODE()
       SELF.AK.AKQ.AlertKeycode = loc:keycode
       GET(SELF.AK.AKQ,SELF.AK.AKQ.AlertKeycode)
       IF NOT ERRORCODE()
          SELF.AK.ProcessAlertKeys(loc:keycode)
       END
    END
 END


