!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: CFCComctrl.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER

 MAP
 END

 INCLUDE('CFCComctrl.inc'),ONCE

_uxthemeLibrary_                 LONG
_Comctl32Library_                LONG
_User32Library_                  LONG
_Msimg32Library_                 LONG
_avicap32Library_                LONG
_Shell32Library_                 LONG
_Wtsapi32Library_                LONG

_CFC_SetWindowTheme_             LONG,STATIC,NAME('CFC_SetWindowTheme')
_CFC_InitCommonControlsEx_       LONG,STATIC,NAME('CFC_InitCommonControlsEx')
_CFC_DllGetVersion_              LONG,STATIC,NAME('CFC_DllGetVersion')
_CFC_SetMenuInfo_                LONG,STATIC,NAME('CFC_SetMenuInfo')
_CFC_GetMenuInfo_                LONG,STATIC,NAME('CFC_GetMenuInfo')
_CFC_GradientFill_               LONG,STATIC,NAME('CFC_GradientFill')
_CFC_GetMenuBarInfo_             LONG,STATIC,NAME('CFC_GetMenuBarInfo')
_CFC_capCreateCaptureWindow_     LONG,STATIC,NAME('CFC_capCreateCaptureWindow')
_CFC_capGetDriverDescription_    LONG,STATIC,NAME('CFC_capGetDriverDescription')
_CFC_SHGetFolderPath_            LONG,STATIC,NAME('CFC_SHGetFolderPath')
_CFC_WTSQuerySessionInformation_ LONG,STATIC,NAME('CFC_WTSQuerySessionInformation')
_CFC_WTSFreeMemory_              LONG,STATIC,NAME('CFC_WTSFreeMemory')
CFCComctrlClass.Construct            PROCEDURE
cstr_uxtheme_Name      CSTRING('uxtheme.dll')
cstrComctl32Name       CSTRING('comctl32.dll')
cstrUser32Name         CSTRING('user32.dll')
cstrMsimg32Name        CSTRING('Msimg32.dll')
cstrAvicap32Name       CSTRING('avicap32.dll')
cstrShell32Name        CSTRING('shell32.dll')
cstrWtsapi32Name       CSTRING('wtsapi32.dll')

cstrProcName           CSTRING('SetWindowTheme')
cstrProcName1          CSTRING('InitCommonControlsEx')
cstrProcName2          CSTRING('DllGetVersion')
cstrProcName3          CSTRING('SetMenuInfo')
cstrProcName4          CSTRING('GetMenuInfo')
cstrProcName5          CSTRING('GradientFill')
cstrProcName6          CSTRING('GetMenuBarInfo')
cstrProcName7          CSTRING('capCreateCaptureWindowA')
cstrProcName8          CSTRING('capGetDriverDescriptionA')
cstrProcName9          CSTRING('SHGetFolderPathA')
cstrProcName10         CSTRING('WTSQuerySessionInformationA')
cstrProcName11         CSTRING('WTSFreeMemory')
 CODE
 IF NOT _uxthemeLibrary_
    _uxthemeLibrary_ = CFC_LoadLibrary(cstr_uxtheme_Name)
    IF _uxthemeLibrary_ ! succesfully loaded
       _CFC_SetWindowTheme_ = CFC_GetProcAddress(_uxthemeLibrary_,cstrProcName)
       SELF._CFC_SetWindowTheme_ = TRUE
    END
 END

 IF NOT _Comctl32Library_
    _Comctl32Library_ = CFC_LoadLibrary(cstrComctl32Name)
    IF _Comctl32Library_
       _CFC_InitCommonControlsEx_ = CFC_GetProcAddress(_Comctl32Library_,cstrProcName1)
       _CFC_DllGetVersion_ = CFC_GetProcAddress(_Comctl32Library_,cstrProcName2)
       SELF._CFC_InitCommonControlsEx_ = TRUE
       SELF._CFC_DllGetVersion_ = TRUE
    END
 END

 IF NOT _User32Library_
    _User32Library_ = CFC_LoadLibrary(cstrUser32Name)
    IF _User32Library_ ! succesfully loaded
       _CFC_SetMenuInfo_ = CFC_GetProcAddress(_User32Library_,cstrProcName3)
       _CFC_GetMenuInfo_ = CFC_GetProcAddress(_User32Library_,cstrProcName4)
       _CFC_GetMenuBarInfo_ = CFC_GetProcAddress(_User32Library_,cstrProcName6)
       SELF._CFC_SetMenuInfo_ = TRUE
       SELF._CFC_GetMenuInfo_ = TRUE
       SELF._CFC_GetMenuBarInfo_ = TRUE
    END
 END

 IF NOT _Msimg32Library_
    _Msimg32Library_ = CFC_LoadLibrary(cstrMsimg32Name)
    IF _Msimg32Library_
       _CFC_GradientFill_ = CFC_GetProcAddress(_Msimg32Library_,cstrProcName5)
       SELF._CFC_GradientFill_ = TRUE
    END
 END

 IF NOT _avicap32Library_
    _avicap32Library_ = CFC_LoadLibrary(cstrAvicap32Name)
    IF _avicap32Library_
       _CFC_capCreateCaptureWindow_ = CFC_GetProcAddress(_avicap32Library_,cstrProcName7)
       _CFC_capGetDriverDescription_ = CFC_GetProcAddress(_avicap32Library_,cstrProcName8)
       SELF._CFC_capCreateCaptureWindow_ = TRUE
       SELF._CFC_capGetDriverDescription_ = TRUE
    END
 END

 IF NOT _Shell32Library_
    _Shell32Library_ = CFC_LoadLibrary(cstrShell32Name)
    IF _Shell32Library_
       _CFC_SHGetFolderPath_ = CFC_GetProcAddress(_Shell32Library_,cstrProcName9)
       SELF._CFC_SHGetFolderPath_ = TRUE
    END
 END

 IF NOT _Wtsapi32Library_
    _Wtsapi32Library_ = CFC_LoadLibrary(cstrWtsapi32Name)
    IF _Wtsapi32Library_
       _CFC_WTSQuerySessionInformation_ = CFC_GetProcAddress(_Wtsapi32Library_,cstrProcName10)
       _CFC_WTSFreeMemory_ = CFC_GetProcAddress(_Wtsapi32Library_,cstrProcName11)
       SELF._CFC_WTSQuerySessionInformation_ = TRUE
       SELF._CFC_WTSFreeMemory_ = TRUE
    END
 END
CFCComctrlClass.Destruct            PROCEDURE
 CODE
 IF _uxthemeLibrary_
    Err# = CFC_FreeLibrary(_uxthemeLibrary_)
 END

 IF _Comctl32Library_
    Err# = CFC_FreeLibrary(_Comctl32Library_)
 END

 IF _User32Library_
    Err# = CFC_FreeLibrary(_User32Library_)
 END

 IF _Msimg32Library_
    Err# = CFC_FreeLibrary(_Msimg32Library_)
 END

 IF _avicap32Library_
    Err# = CFC_FreeLibrary(_avicap32Library_)
 END

 IF _Shell32Library_
    Err# = CFC_FreeLibrary(_Shell32Library_)
 END

CFCComctrlClass.Init          PROCEDURE
icex                   LIKE(CFC_INITCOMMONCONTROLSEX)
 CODE
 ! init common controls
 icex.dwSize = SIZE(CFC_INITCOMMONCONTROLSEX)
 icex.dwICC   = CFC_ICC_COOL_CLASSES + CFC_ICC_BAR_CLASSES + CFC_ICC_WIN95_CLASSES

 ! if function is successfully loaded
 IF _CFC_InitCommonControlsEx_ 
    CFC_InitCommonControlsEx(ADDRESS(icex))
 END
CFCComctrlClass.DisableWindowsTheme     PROCEDURE(ULONG in_hwnd)
cstrTheme  CSTRING(32) ! ansi string
cstrThemeW CSTRING(16) ! unicode string
 CODE
 IF NOT _CFC_SetWindowTheme_ THEN RETURN -1.     ! function call failed
 cstrTheme = ' '                                 ! "space" char
 Err# = CFC_MultiByteToWideChar(CFC_GetACP(),  | ! code page
                          0,    |                ! character-type options
                         ADDRESS(cstrTheme), |   ! string to map
                         SIZE(cstrTheme),    |   ! number of bytes in string
                         ADDRESS(cstrThemeW),  | ! wide-character buffer
                         SIZE(cstrThemeW))
 RETURN CFC_SetWindowTheme(in_hwnd,ADDRESS(cstrThemeW),ADDRESS(cstrThemeW)) ! returns 0 if successfull

CFCComctrlClass.GetComctrlVer     PROCEDURE
loc:DllVersionInfo         LIKE(CFC_DllVersionInfo)
 CODE
 CLEAR(loc:DllVersionInfo)
 loc:DllVersionInfo.cbSize = SIZE(CFC_DllVersionInfo)
 IF _CFC_DllGetVersion_
    Err# = CFC_DllGetVersion(ADDRESS(loc:DllVersionInfo))
 END

 RETURN CLIP(loc:DllVersionInfo.dwMajorVersion)&'.'&CLIP(loc:DllVersionInfo.dwMinorVersion)

 
 
CFCComctrlClass.RetrieveSystemMenuFont PROCEDURE
loc:SPI_GETNONCLIENTMETRICS    EQUATE(41)
loc:NONCLIENTMETRICS           LIKE(CFC_NONCLIENTMETRICS)
 code
 loc:NONCLIENTMETRICS.cbSize = SIZE(CFC_NONCLIENTMETRICS)
 Err# = CFC_SystemParametersInfo(loc:SPI_GETNONCLIENTMETRICS,SIZE(CFC_NONCLIENTMETRICS),ADDRESS(loc:NONCLIENTMETRICS),0)
 RETURN CFC_CreateFontIndirect(ADDRESS(loc:NONCLIENTMETRICS.lfMenuFont))
CFCComctrlClass.GetOSVersion PROCEDURE
loc:vi         LIKE(CFC_OSVERSIONINFO)
loc:RetValue   STRING(100)
 CODE
 loc:vi.dwOSVersionInfoSize = SIZE(CFC_OSVERSIONINFO)
 IF CFC_GetVersionEx(ADDRESS(loc:vi))
    CASE loc:vi.dwPlatformId
    OF CFC_VER_PLATFORM_WIN32s
       loc:RetValue = 'Microsoft Win32s'
    OF CFC_VER_PLATFORM_WIN32_NT
       IF loc:vi.dwMajorVersion = 6 AND loc:vi.dwMinorVersion = 1
          loc:RetValue = 'Microsoft Windows 7'
       END

       IF loc:vi.dwMajorVersion = 6 AND loc:vi.dwMinorVersion = 0
          loc:RetValue = 'Microsoft Windows Vista'
       END

       IF loc:vi.dwMajorVersion = 5 AND loc:vi.dwMinorVersion = 2
          loc:RetValue = 'Microsoft Windows Server 2003'
       END
       
       IF loc:vi.dwMajorVersion = 5 AND loc:vi.dwMinorVersion = 1
          loc:RetValue = 'Microsoft Windows XP'
       END

       IF loc:vi.dwMajorVersion = 5 AND loc:vi.dwMinorVersion = 0
          loc:RetValue = 'Microsoft Windows 2000'
       END
       IF loc:vi.dwMajorVersion <= 4
          loc:RetValue = 'Microsoft Windows NT'
       END
    OF CFC_VER_PLATFORM_WIN32_WINDOWS
       IF loc:vi.dwMajorVersion = 4 AND loc:vi.dwMinorVersion = 0
          loc:RetValue = 'Microsoft Windows 95'
       END
       IF loc:vi.dwMajorVersion = 4 AND loc:vi.dwMinorVersion = 10
          loc:RetValue = 'Microsoft Windows 98'
       END
       IF loc:vi.dwMajorVersion = 4 AND loc:vi.dwMinorVersion = 90
          loc:RetValue = 'Microsoft Windows Millennium Edition'
       END
    END
    loc:RetValue = loc:vi.dwMajorVersion&'.'&loc:vi.dwMinorVersion & '.' & loc:vi.dwBuildNumber & ' ' & CLIP(loc:RetValue)
 END
 
 RETURN loc:RetValue
CFCComctrlClass.IsWindows2000orLater PROCEDURE
loc:vi         LIKE(CFC_OSVERSIONINFO)
loc:RetValue   BYTE
 CODE
 loc:vi.dwOSVersionInfoSize = SIZE(CFC_OSVERSIONINFO)
 IF CFC_GetVersionEx(ADDRESS(loc:vi))
    IF loc:vi.dwMajorVersion >= 5
       loc:RetValue = TRUE
    END
 END
 RETURN loc:RetValue
CFCComctrlClass.IsWindowsXPorLater PROCEDURE
loc:vi         LIKE(CFC_OSVERSIONINFO)
loc:RetValue   BYTE
 CODE
 loc:vi.dwOSVersionInfoSize = SIZE(CFC_OSVERSIONINFO)
 IF CFC_GetVersionEx(ADDRESS(loc:vi))
    IF loc:vi.dwMajorVersion > 5 OR (loc:vi.dwMajorVersion = 5 AND loc:vi.dwMinorVersion >= 1)
       loc:RetValue = TRUE
    END
 END
 RETURN loc:RetValue
CFCComctrlClass.IsWindowsVistaOrLater PROCEDURE
loc:vi         LIKE(CFC_OSVERSIONINFO)
loc:RetValue   BYTE
 CODE
 loc:vi.dwOSVersionInfoSize = SIZE(CFC_OSVERSIONINFO)
 IF CFC_GetVersionEx(ADDRESS(loc:vi))
    IF loc:vi.dwMajorVersion >= 6 AND loc:vi.dwBuildNumber >= 6000
       loc:RetValue = TRUE
    END
 END
 RETURN loc:RetValue

CFCComctrlClass.IsWindows7OrLater PROCEDURE
loc:vi         LIKE(CFC_OSVERSIONINFO)
loc:RetValue   BYTE
 CODE
 loc:vi.dwOSVersionInfoSize = SIZE(CFC_OSVERSIONINFO)
 IF CFC_GetVersionEx(ADDRESS(loc:vi))
    IF loc:vi.dwMajorVersion >= 6 AND loc:vi.dwMinorVersion >= 1
       loc:RetValue = TRUE
    END
 END
 RETURN loc:RetValue
CFCComctrlClass.GetTempPath PROCEDURE
cstr_Buffer    CSTRING(260)
 CODE
 CFC_GetTempPath(SIZE(cstr_Buffer),ADDRESS(cstr_Buffer))
 RETURN CLIP(cstr_Buffer)

CFCComctrlClass.GetTempFileName PROCEDURE(STRING inPath, STRING inPrefix)
cstr_Path   CSTRING(260)
cstr_Prefix CSTRING(10)
cstr_Result CSTRING(260)
 CODE
 cstr_Path = inPath
 cstr_Prefix = inPrefix
 CFC_GetTempFileName(ADDRESS(cstr_Path),ADDRESS(cstr_Prefix),0,ADDRESS(cstr_Result))
 REMOVE(CLIP(cstr_Result))
 RETURN CLIP(cstr_Result)
CFCComctrlClass.GetLocalPath PROCEDURE
cstr_Path                  CSTRING(260)
loc:CSIDL_LOCAL_APPDATA    EQUATE(01CH)
 CODE
 cstr_Path = ''
 IF SELF._CFC_SHGetFolderPath_
    IF CFC_SHGetFolderPath(0,loc:CSIDL_LOCAL_APPDATA,0,0,ADDRESS(cstr_Path))
       cstr_Path = ''
    END
 END
 RETURN cstr_Path
CFCComctrlClass.GetClientName PROCEDURE(*STRING out_ClientName)
loc:WTS_CURRENT_SERVER_HANDLE EQUATE(0)
loc:WTS_CURRENT_SESSION       EQUATE(-1)
loc:cstrClientName            &CSTRING
loc:addrBuffer                LONG
loc:BytesReturned             LONG
loc:RetVal                    LONG
 CODE
 IF NOT CFC_WTSQuerySessionInformation(loc:WTS_CURRENT_SERVER_HANDLE,loc:WTS_CURRENT_SESSION,10,ADDRESS(loc:addrBuffer),ADDRESS(loc:BytesReturned))
    loc:RetVal = CFC_GetLastError()
    out_ClientName = ''
 ELSE
    loc:cstrClientName &= (loc:addrBuffer)
    out_ClientName = loc:cstrClientName
    CFC_WTSFreeMemory(loc:addrBuffer)
 END
 RETURN loc:RetVal
! ********************************************************************************************************
CFCCommandCnt.Init                 PROCEDURE(LONG inStartID)
 CODE
 SELF.ID = inStartID
CFCCommandCnt.GetNextID            PROCEDURE
 CODE
 SELF.ID += 1
 RETURN SELF.ID

! ********************************************************************************************************


