
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Declaration File Contents
!!!!! File Name: CFCMenus.inc
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

OMIT('_EndOfInclude_',_CFCMenusClassPresent_)
_CFCMenusClassPresent_               EQUATE(1)

 INCLUDE('CFCAPI.inc'),ONCE
 INCLUDE('CFCWndProc.inc'),ONCE
 INCLUDE('CFCGDI.inc'),ONCE
 INCLUDE('CFCComctrl.inc'),ONCE
 INCLUDE('CFCTooltips.inc'),ONCE

 MAP
 END

CFCMenuQueue                QUEUE,TYPE
Menu                           &CFCMenuBase
                            END

CFCMenuItemQueue            QUEUE,TYPE
MenuItem                       &CFCMenuItem
                            END

CFCMenuMdiChildWindowsQueue QUEUE,TYPE
Caption                        STRING(255)
hwnd                           ULONG
                            END


CFCMenuManager    CLASS(CFCWndProc),TYPE,MODULE('CFCMenus.clw'),LINK('CFCMenus.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
MQ                   &CFCMenuQueue
MDIChildQ            &CFCMenuMdiChildWindowsQueue
FlagSuppressAlt           BYTE
FlagIsWindows7OrLater     BYTE
Construct            PROCEDURE
Destruct             PROCEDURE
AddMenu              PROCEDURE(*CFCMenuBase inMenu)
DeleteMenu           PROCEDURE(*CFCMenuBase inMenu)
GetMenuItemByID      PROCEDURE(LONG inMenuItemID),*CFCMenuItem
GetMenuItemByStrID   PROCEDURE(STRING inMenuItemID),*CFCMenuItem
GetAnyTopLevelItemByhWnd PROCEDURE(ULONG hwnd),*CFCMenuItem
CallBackProc         PROCEDURE(ULONG hWnd,ULONG Msg,ULONG wParam,LONG lParam),LONG,VIRTUAL
OnCommand            PROCEDURE(LONG inID)
OnMeasureItem        PROCEDURE(ULONG hWnd,LONG lParam)
OnDrawItem           PROCEDURE(ULONG hWnd,LONG lParam)
OnInitMenuPopup      PROCEDURE(ULONG wParam)
OnUninitMenuPopup    PROCEDURE(ULONG wParam)
OnNCMouseMove        PROCEDURE(SHORT x,SHORT y)
OnEraseBkgnd         PROCEDURE(ULONG hwnd)
OnNCActivate         PROCEDURE(ULONG hwnd)
FillMDIChildWindows  PROCEDURE(ULONG in_MDIParent_hwnd)
                  END

CFCMenuBase       CLASS,TYPE,MODULE('CFCMenus.clw'),LINK('CFCMenus.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
hMenu                 ULONG           ! handle of menu
hbrBack               ULONG           ! hBrush of menubar background
BkrColor              ULONG           ! menubar background color
hWnd                  ULONG           ! window handle

MIQ                   &CFCMenuItemQueue
GDI                   &CFCGDIClass
Comctrl               &CFCComctrlClass

Construct             PROCEDURE
Destruct              PROCEDURE
CreateMenu            PROCEDURE,LONG
GetMenuItemByID       PROCEDURE(LONG inMenuItemID),*CFCMenuItem
GetMenuItemByStrID    PROCEDURE(STRING inMenuItemID),*CFCMenuItem
GetMenuItemCount      PROCEDURE,LONG
GetMenuItemPos        PROCEDURE(*CFCMenuItem inMenuItem),LONG
SetBackground         PROCEDURE(ULONG inColor),LONG,PROC
SetComctrlClass       PROCEDURE(*CFCComctrlClass inComctrl)
SetDrawingClass       PROCEDURE(*CFCMenuItemDrawClass inDrawingClass,<BYTE inExcludeSubmenus>)
IsSubMenusExists      PROCEDURE,BYTE
OnInitMenuPopup       PROCEDURE,VIRTUAL
OnUninitMenuPopup     PROCEDURE,VIRTUAL
Kill                  PROCEDURE

SetDrawingClass       PROCEDURE(*CFCMenuItemDrawClass inDrawingClass,BYTE inExcludeSubmenus,*CFCMenuBase inMenuBase),PROTECTED
                  END

CFCMenu           CLASS(CFCMenuBase),TYPE,MODULE('CFCMenus.clw'),LINK('CFCMenus.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
CreateMenu           PROCEDURE,LONG                  ! create the menu
SetMenuToWnd         PROCEDURE(ULONG in_hWnd),LONG   ! set menu to window
Update               PROCEDURE                       ! draw menubar
                  END

CFCPopupMenu      CLASS(CFCMenuBase),TYPE,MODULE('CFCMenus.clw'),LINK('CFCMenus.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
CreateMenu           PROCEDURE,LONG
Run                  PROCEDURE(ULONG hWnd,<LONG x>,<LONG y>),LONG,PROC
                  END

CFCMenuItem       CLASS,TYPE,MODULE('CFCMenus.clw'),LINK('CFCMenus.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
ID                   LONG
strID                STRING(255)
Text                 STRING(255)
cstrText             &CSTRING
FlagSeparator        BYTE
FlagTopLevel         BYTE

IconName             STRING(255)
hIcon                ULONG
hIconDisabled        ULONG
IconWidth            LONG
IconHeight           LONG

CheckedIconName      STRING(255)
hCheckedIconDisabled ULONG
hCheckedIcon         ULONG


rcItem               LIKE(CFC_RECT)

FlagSubmenuIsOpened  BYTE

Menu                 &CFCMenuBase
SubMenu              &CFCMenuBase
Cnt                  &CFCCommandCnt
DrawingClass         &CFCMenuItemDrawClass

Construct            PROCEDURE
Destruct             PROCEDURE
SetCommandCnt        PROCEDURE(*CFCCommandCnt inCnt)
GetMenuItemText      PROCEDURE(),STRING
SetMenuItemText      PROCEDURE(STRING inMenuItemText),LONG,PROC
SetMenuItemStrID     PROCEDURE(STRING inMenuItemID)
AttachSubmenu        PROCEDURE(*CFCMenuBase inMenu),LONG
DetachSubmenu        PROCEDURE,LONG
GetSubmenu           PROCEDURE(),*CFCMenuBase
InsertMenuItem       PROCEDURE(*CFCMenuBase inMenu,STRING inMenuItemText),LONG,PROC
InsertMenuItemByPos  PROCEDURE(*CFCMenuBase inMenu,STRING inMenuItemText,LONG inPos),LONG,PROC
InsertSeparator      PROCEDURE(*CFCMenuBase inMenu),LONG,PROC
InsertSeparatorByPos PROCEDURE(*CFCMenuBase inMenu,LONG inPos),LONG,PROC
SetMenuItemChecked   PROCEDURE,LONG,PROC
SetMenuItemUnchecked PROCEDURE,LONG,PROC
IsMenuItemChecked    PROCEDURE,LONG
SetMenuItemDisabled  PROCEDURE,LONG,PROC
SetMenuItemEnabled   PROCEDURE,LONG,PROC
IsMenuItemDisabled   PROCEDURE,LONG
SetIcon              PROCEDURE(STRING inIconName,<STRING inDllName>,<LONG inWidth>,<LONG inHeight>),LONG,PROC
SetCheckedIcon       PROCEDURE(STRING inIconName,<STRING inDllName>,<LONG inWidth>,<LONG inHeight>),LONG,PROC
OnClick              PROCEDURE(),VIRTUAL
OnMeasureItem        PROCEDURE(ULONG hWnd,LONG lParam),VIRTUAL
OnDrawItem           PROCEDURE(ULONG hWnd,LONG lParam),VIRTUAL
SetOwnerdraw         PROCEDURE,VIRTUAL
RemoveOwnerdraw      PROCEDURE,VIRTUAL
DrawTopLevelItem     PROCEDURE,VIRTUAL
DrawMenuBar1px       PROCEDURE,VIRTUAL
SetTopLevel          PROCEDURE
SetDrawingClass      PROCEDURE(*CFCMenuItemDrawClass inDrawingClass)
GetDrawingClass      PROCEDURE,*CFCMenuItemDrawClass
UpdateMenuItem       PROCEDURE,VIRTUAL
DeleteMenuItem       PROCEDURE,LONG
AddMenuItem          PROCEDURE(*CFCMenuBase inMenu,STRING inMenuItemText,*CFCCommandCnt inCnt,<BYTE inFlagTopLevel>,<STRING inItemStrID>),LONG,PROC
AddSeparator         PROCEDURE(*CFCMenuBase inMenu,*CFCCommandCnt inCnt,<STRING inItemStrID>),LONG,PROC
                  END

! the class for drawing the menu item
CFCMenuItemDrawClass     CLASS,TYPE,MODULE('CFCMenus.clw'),LINK('CFCMenus.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
MenuItemTextOffset          LONG            ! offset (px) for menu items text
FlagDoNotDrawTopLevel       BYTE
OnMeasureItem               PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd,LONG lParam),VIRTUAL
OnDrawItem                  PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd,LONG lParam),VIRTUAL
SetOwnerdraw                PROCEDURE(*CFCMenuItem CurrItem),VIRTUAL
RemoveOwnerdraw             PROCEDURE(*CFCMenuItem CurrItem),VIRTUAL
UpdateMenuItem              PROCEDURE(*CFCMenuItem CurrItem),VIRTUAL
DrawTopLevelItem            PROCEDURE(*CFCMenuItem CurrItem),VIRTUAL
DrawMenuBar1px              PROCEDURE(*CFCMenuItem CurrItem),VIRTUAL
                         END

CFCMenuItemDrawClass:Std CLASS(CFCMenuItemDrawClass),TYPE,MODULE('CFCMenus.clw'),LINK('CFCMenus.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
Construct                   PROCEDURE
Destruct                    PROCEDURE
OnMeasureItem               PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd,LONG lParam),VIRTUAL
OnDrawItem                  PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd,LONG lParam),VIRTUAL
                         END

CFCMenuItemDrawClass:XP   CLASS(CFCMenuItemDrawClass),TYPE,MODULE('CFCMenus.clw'),LINK('CFCMenus.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
ItemHeight                   LONG            ! menu item height, px
IconBarWidth                 LONG            ! icon bar width, px
SubMenuOffset                LONG            ! offset,px, if submenu exists

Color:ItemBackground         LONG            ! colors
Color:SelectedItem           LONG
Color:DisabledItemBackground LONG
Color:ItemBorder             LONG
Color:PopupWindowBorder      LONG
Color:Separator              LONG
Color:Shadow:1               LONG
Color:Shadow:2               LONG


Construct                    PROCEDURE
Destruct                     PROCEDURE
DrawItemText                 PROCEDURE(*CFCMenuItem CurrItem,LONG hDC,CFC_RECT inRect)
DrawShadow                   PROCEDURE(CFC_RECT rcInfo,ULONG hDC)

OnMeasureItem                PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd,LONG lParam),VIRTUAL
OnDrawItem                   PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd,LONG lParam),VIRTUAL
SetOwnerdraw                 PROCEDURE(*CFCMenuItem CurrItem),VIRTUAL
DrawFlatWindow               PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd),VIRTUAL
DrawTopLevelItem             PROCEDURE(*CFCMenuItem CurrItem),VIRTUAL
                         END

CFCMenuItemDrawClass:2003        CLASS(CFCMenuItemDrawClass:XP),TYPE,MODULE('CFCMenus.clw'),LINK('CFCMenus.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
Color:IconBarGradientFrom            LONG
Color:IconBarGradientTo              LONG
Color:TopLevelItemGradientFrom       LONG
Color:TopLevelItemGradientTo         LONG
Color:OpenedTopLevelItemGradientFrom LONG
Color:OpenedTopLevelItemGradientTo   LONG


Construct                            PROCEDURE
Destruct                             PROCEDURE
DrawFlatWindow                       PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd),VIRTUAL
OnDrawItem                           PROCEDURE(*CFCMenuItem CurrItem,ULONG hWnd,LONG lParam),VIRTUAL
                                 END


CFCMenuItemDrawClass:2003:Gray   CLASS(CFCMenuItemDrawClass:2003),TYPE,MODULE('CFCMenus.clw'),LINK('CFCMenus.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
Construct                           PROCEDURE
                                 END

CFCMenuItemDrawClass:2003:Green  CLASS(CFCMenuItemDrawClass:2003),TYPE,MODULE('CFCMenus.clw'),LINK('CFCMenus.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
Construct                           PROCEDURE
                                 END

CFCMenuItemDrawClass:2003:Silver CLASS(CFCMenuItemDrawClass:2003),TYPE,MODULE('CFCMenus.clw'),LINK('CFCMenus.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
Construct                           PROCEDURE
                                 END

_EndOfInclude_


