
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Declaration File Contents
!!!!! File Name: CFCQLocator.inc
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

OMIT('_EndOfInclude_',_CFCQueueLocatorClassPresent_)

 INCLUDE('CFCWndProc.inc'),ONCE
 INCLUDE('CFCAPI.inc'),ONCE
 INCLUDE('keycodes.clw'),ONCE

_CFCQueueLocatorClassPresent_    EQUATE(1)

CFCQueueLocatorClass             CLASS(CFCWndProc),TYPE,MODULE('CFCQLocator.clw'),LINK('CFCQLocator.clw',_CFCLinkMode_),DLL(_CFCDllMode_)
LocatorQueue                        &QUEUE            ! queue in list box
QueueField                          ANY               ! the search field in queue
LocatorVariable                     ANY               ! the variable for locator control
LocatorFeq                          LONG              ! FEQ of locator control
ListBoxFeq                          LONG              ! FEQ of list box
cstrLocatorVariable                 CSTRING(1024)     ! CSTRING variable for locator
FlagUseLocator                      BYTE              ! the flag: use locator
TimerID                             ULONG             ! timer ID
LastLetterTime                      ULONG             ! time which store the time when we pressed the key last time
ClearTime                           ULONG             ! the period, Locator will be cleared when this period elapsed

Construct                           PROCEDURE
Init                                PROCEDURE(*QUEUE inLocatorQueue,LONG inListBoxFeq,<*ANY inLocatorVariable>,<LONG inLocatorFeq>)
Kill                                PROCEDURE
SetActiveLocator                    PROCEDURE(*ANY inQueueField)
SetClearTime                        PROCEDURE(LONG inTime)
NewSelection                        PROCEDURE
ClearLocator                        PROCEDURE
RemoveLocator                       PROCEDURE
TakeAccepted                        PROCEDURE,VIRTUAL
CallBackProc                        PROCEDURE(ULONG hWnd,ULONG inMsg,ULONG wParam,LONG lParam),LONG,VIRTUAL
                                 END

_EndOfInclude_


