!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: CFCWndProc.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER
 MAP
    CFCCallBackProc(ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam),LONG,PASCAL
    CFCCallBackProc1(ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam),LONG,PASCAL
    CFCCallBackProc2(ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam),LONG,PASCAL
    CFCCallBackProc3(ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam),LONG,PASCAL
    CFCCallBackProc4(ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam),LONG,PASCAL
    CFCCallBackProc5(ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam),LONG,PASCAL
    CFCCallBackProc6(ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam),LONG,PASCAL
    CFCCallBackProc7(ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam),LONG,PASCAL
    CFCPropEnumProc(ULONG hwnd,LONG lpszString,ULONG hData,LONG dwData),BOOL,PASCAL
 END

 INCLUDE('CFCWndProc.inc'),ONCE

CFCCallBackClassProp  CSTRING('CFCCallBackClassProp')
CFCCallBackClassProp1 CSTRING('CFCCallBackClassProp1')
CFCCallBackClassProp2 CSTRING('CFCCallBackClassProp2')
CFCCallBackClassProp3 CSTRING('CFCCallBackClassProp3')
CFCCallBackClassProp4 CSTRING('CFCCallBackClassProp4')
CFCCallBackClassProp5 CSTRING('CFCCallBackClassProp5')
CFCCallBackClassProp6 CSTRING('CFCCallBackClassProp6')
CFCCallBackClassProp7 CSTRING('CFCCallBackClassProp7')
! ************************************************************************************************
CFCWndProc.SetCallBack PROCEDURE(LONG inhWnd,<LONG inControlFEQ>)
 code
 if OMITTED(3)  then inControlFEQ = 0.
 SELF.ControlFEQ = inControlFEQ
 SELF.WndHandle = inhWnd
 SELF.ThreadNo = THREAD()

 SELF.PL &= new(CFC_TQPropertyList)
 if NOT SELF.PL &= NULL
    free(SELF.PL)
 end

 SELF.PropNum = SELF.TakePropNumber()

 case clip(CFCCallBackClassProp)&clip(format(self.PropNum,@n1b))
    of CFCCallBackClassProp
       CFC_SetProp(SELF.WndHandle,CFCCallBackClassProp,ADDRESS(SELF))
       SELF.WndProc = CFC_SetWindowLong(self.WndHandle,-4,ADDRESS(CFCCallBackProc))
    of CFCCallBackClassProp1
       CFC_SetProp(SELF.WndHandle,CFCCallBackClassProp1,ADDRESS(SELF))
       SELF.WndProc = CFC_SetWindowLong(self.WndHandle,-4,ADDRESS(CFCCallBackProc1))
    of CFCCallBackClassProp2
       CFC_SetProp(SELF.WndHandle,CFCCallBackClassProp2,ADDRESS(SELF))
       SELF.WndProc = CFC_SetWindowLong(self.WndHandle,-4,ADDRESS(CFCCallBackProc2))
    of CFCCallBackClassProp3
       CFC_SetProp(SELF.WndHandle,CFCCallBackClassProp3,ADDRESS(SELF))
       SELF.WndProc = CFC_SetWindowLong(self.WndHandle,-4,ADDRESS(CFCCallBackProc3))
    of CFCCallBackClassProp4
       CFC_SetProp(SELF.WndHandle,CFCCallBackClassProp4,ADDRESS(SELF))
       SELF.WndProc = CFC_SetWindowLong(self.WndHandle,-4,ADDRESS(CFCCallBackProc4))
    of CFCCallBackClassProp5
       CFC_SetProp(SELF.WndHandle,CFCCallBackClassProp5,ADDRESS(SELF))
       SELF.WndProc = CFC_SetWindowLong(self.WndHandle,-4,ADDRESS(CFCCallBackProc5))
    of CFCCallBackClassProp6
       CFC_SetProp(SELF.WndHandle,CFCCallBackClassProp6,ADDRESS(SELF))
       SELF.WndProc = CFC_SetWindowLong(self.WndHandle,-4,ADDRESS(CFCCallBackProc6))
    of CFCCallBackClassProp7
       CFC_SetProp(SELF.WndHandle,CFCCallBackClassProp7,ADDRESS(SELF))
       SELF.WndProc = CFC_SetWindowLong(self.WndHandle,-4,ADDRESS(CFCCallBackProc7))
 end
! ************************************************************************************************
CFCWndProc.CallBackProc PROCEDURE(ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam)
 code
 RETURN CFC_CallWindowProc(SELF.WndProc,hWnd,winMsg,wParam,lParam)
! ************************************************************************************************
CFCWndProc.RemoveCallBack PROCEDURE
cstrProp   CSTRING(256)
 code
 CFC_SetWindowLong(SELF.WndHandle,-4,SELF.WndProc)
 cstrProp = clip(CFCCallBackClassProp) & clip(format(SELF.PropNum,@n1b))
 CFC_RemoveProp(SELF.WndHandle,cstrProp)
 if NOT SELF.PL &= NULL
    free(SELF.PL)
    dispose(SELF.PL)
 end
! ************************************************************************************************
CFCWndProc.TakePropNumber  PROCEDURE
ReturnValue    BYTE !   
 code
 free(SELF.PL)
 Err# = CFC_EnumPropsEx(SELF.WndHandle,address(CFCPropEnumProc),address(SELF))

 if NOT SELF.PL &= NULL
    loop num# = 0 to 7
       SELF.PL.Property = clip(CFCCallBackClassProp) & clip(format(num#,@n1b))
       get(SELF.PL,SELF.PL.Property)
       if errorcode()
          ReturnValue = num#
          break
       end
    end
 end
 RETURN ReturnValue
! ************************************************************************************************
CFCCallBackProc PROCEDURE(ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam)
CallbackRef   &CFCWndProc
 code
 CallbackRef &= (CFC_GetProp(hWnd,CFCCallBackClassProp))
 RETURN CallbackRef.CallBackProc(hWnd,winMsg,wParam,lParam)
! ************************************************************************************************
CFCCallBackProc1 PROCEDURE(ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam)
CallbackRef   &CFCWndProc
 code
 CallbackRef &= (CFC_GetProp(hWnd,CFCCallBackClassProp1))
 RETURN CallbackRef.CallBackProc(hWnd,winMsg,wParam,lParam)
! ************************************************************************************************
CFCCallBackProc2 PROCEDURE(ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam)
CallbackRef   &CFCWndProc
 code
 CallbackRef &= (CFC_GetProp(hWnd,CFCCallBackClassProp2))
 RETURN CallbackRef.CallBackProc(hWnd,winMsg,wParam,lParam)
! ************************************************************************************************
CFCCallBackProc3 PROCEDURE(ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam)
CallbackRef   &CFCWndProc
 code
 CallbackRef &= (CFC_GetProp(hWnd,CFCCallBackClassProp3))
 RETURN CallbackRef.CallBackProc(hWnd,winMsg,wParam,lParam)
! ************************************************************************************************
CFCCallBackProc4 PROCEDURE(ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam)
CallbackRef   &CFCWndProc
 code
 CallbackRef &= (CFC_GetProp(hWnd,CFCCallBackClassProp4))
 RETURN CallbackRef.CallBackProc(hWnd,winMsg,wParam,lParam)
! ************************************************************************************************
CFCCallBackProc5 PROCEDURE(ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam)
CallbackRef   &CFCWndProc
 code
 CallbackRef &= (CFC_GetProp(hWnd,CFCCallBackClassProp5))
 RETURN CallbackRef.CallBackProc(hWnd,winMsg,wParam,lParam)
! ************************************************************************************************
CFCCallBackProc6 PROCEDURE(ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam)
CallbackRef   &CFCWndProc
 code
 CallbackRef &= (CFC_GetProp(hWnd,CFCCallBackClassProp6))
 RETURN CallbackRef.CallBackProc(hWnd,winMsg,wParam,lParam)
! ************************************************************************************************
CFCCallBackProc7 PROCEDURE(ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam)
CallbackRef   &CFCWndProc
 code
 CallbackRef &= (CFC_GetProp(hWnd,CFCCallBackClassProp7))
 RETURN CallbackRef.CallBackProc(hWnd,winMsg,wParam,lParam)
! ************************************************************************************************
CFCPropEnumProc PROCEDURE(ULONG hwnd,LONG lpszString,ULONG hData,LONG dwData)
CallbackRef        &CFCWndProc
strProperty        CSTRING(256)
refCSTRING         &CSTRING
 code
 if lpszString > 65535 !  ,   
    strProperty = ''
    CFC_memcpy(address(strProperty),lpszString,255)
    CallbackRef &= (dwData)
    if NOT CallbackRef &= NULL
       CallbackRef.PL.Property = clip(strProperty)
       add(CallbackRef.PL)
    end
 end
 return TRUE


